#include<iostream>
using namespace std;
int main()
{
	int n,k,a[100][100],br=0;;
	bool t1=false,t2=false,t3=false,t4=false,t5=false,t6=false,t7=false,t8=false,t9=false;
	bool b1=false,b2=false,b3=false,b4=false,b5=false,b6=false,b7=false,b8=false,b9=false;
	
	cin>>n>>k;
	for(int i=0;i<n;i++)
	{
		for(int j=0;j<k;j++)
		{
			cin>>a[i][j];
		}
	}
	
	for(int i=0;i<n;i++)
	{
	for(int j=0;j<k;j++)
		{
			if(a[i][j]==1)
			{
				if(t1==true)
				{
					if(a[i][j]!=a[i-1][j])
					b1=true;
				}
				else
				if(a[i][j]!=a[i][j+1])
				t1=true;
			}
			else
			if(a[i][j]==2)
			{
				if(t2==true)
				{
					if(a[i][j]!=a[i-1][j])
					b2=true;
				}
				else
				if(a[i][j]!=a[i][j+1])
				t2=true;
			}
			else
			if(a[i][j]==3)
			{
				if(t3==true)
				{
					if(a[i][j]!=a[i-1][j])
					b3=true;
				}
				else
				if(a[i][j]!=a[i][j+1])
				t3=true;
			}
			else
			if(a[i][j]==4)
			{
				if(t4==true)
				{
					if(a[i][j]!=a[i-1][j])
					b4=true;
				}
				else
				if(a[i][j]!=a[i][j+1])
				t4=true;
			}
			else
			if(a[i][j]==5)
			{
				if(t5==true)
				{
					if(a[i][j]!=a[i-1][j])
					b5=true;
				}
				else
				if(a[i][j]!=a[i][j+1])
				t5=true;
			}
			else
			if(a[i][j]==6)
			{
				if(t6==true)
				{
					if(a[i][j]!=a[i-1][j])
					b6=true;
				}
				else
				if(a[i][j]!=a[i][j+1])
				t6=true;
			}
			else
			if(a[i][j]==7)
			{
				if(t7==true)
				{
					if(a[i][j]!=a[i-1][j])
					b7=true;
				}
				else
				if(a[i][j]!=a[i][j+1])
				t7=true;
			}
			else
			if(a[i][j]==8)
			{
				if(t8==true)
				{
					if(a[i][j]!=a[i-1][j])
					b8=true;
				}
				else
				if(a[i][j]!=a[i][j+1])
				t8=true;
			}
			else
			if(a[i][j]==9)
			{
				if(t9==true)
				{
					if(a[i][j]!=a[i-1][j])
					b9=true;
				}
				else
				if(a[i][j]!=a[i][j+1])
				t9=true;
			}
		}
	}
		
		if(t1==true&&b1==false)
		br++;
		if(t2==true&&b2==false)
		br++;
		if(t3==true&&b3==false)
		br++;
		if(t4==true&&b4==false)
		br++;
		if(t5==true&&b5==false)
		br++;
		if(t6==true&&b6==false)
		br++;
		if(t7==true&&b7==false)
		br++;
		if(t8==true&&b8==false)
		br++;
		if(t9==true&&b9==false)
		br++;
		cout<<br;
		return 0;
}